/////////////////////////////////////////////////
// Time to String conversion routines. Reproduce ansi c behaviour.
//
/////////////////////////////////////////////////
#include "time.h"
#define MONSPERYEAR 12
#define DAYSPERNYEAR 365
#define DAYSPERLYEAR 366
#define HOURSPERDAY 24
#define SECSPERMIN	60
#define SECSPERHOUR 3600
#define MINSPERHOUR	60
#define DAYSPERWEEK 7
#define SECSPERDAY	86400

#define SECSPER4YEARS	(SECSPERDAY*DAYSPERNYEAR*3+SECSPERDAY*DAYSPERLYEAR)
#define SECSPERNYEAR	(SECSPERDAY*DAYSPERNYEAR)
#define SECSPERLYEAR	(SECSPERDAY*DAYSPERLYEAR)

// start date is 00:00 01 January 2000. this is visokosnyi god.
#define START 2000

char tm_sec;     /* seconds after the minute - [0,59] */
char tm_min;     /* minutes after the hour - [0,59] */
char tm_hour;    /* hours since midnight - [0,23] */
char tm_mday;    /* day of the month - [1,31] */
char tm_mon;     /* months since January - [1,12] */
int tm_year;    /* year */


const char code mon_lengths[2][MONSPERYEAR] ={{31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31},
										 {31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 }};

int	getyear(time_t tm_t)  // time is given relative to 1 January 2000
{
	int iTemp;
	int iYears;
	time_t iRem;

	iTemp=tm_t/SECSPER4YEARS;
	iRem=tm_t-iTemp*SECSPER4YEARS;
	iYears=START+iTemp*4;

	iRem=iRem-SECSPERLYEAR;
	if (iRem>=0)
	{
		do
		{	
			iYears++;
			iRem=iRem-SECSPERNYEAR;
		}
		while(iRem>=0);
	}
	
	return	iYears;
}

char isvisokos(int iYear)
{
	if (iYear%4==0)	/// ???????????????????????? %100 ?
		return 1;

	return 0;
}

// returns number of months in last year
// if rem pointer is not null it returns remainder - days,hours, minutes, secs.
char getmonth (time_t tm_t, time_t *rem) // time is in seconds absolute
{
	int iYear;
	int iCurYear;
	time_t iRem;
	char isVisokos=1;
	char iMonth=0;

	iYear=getyear(tm_t);
	iCurYear=iYear;
	
	while(!isvisokos(iYear))	// find previous visokos year
	{
		iYear--;
	}
	
	iRem=tm_t-(iYear-START)/4*SECSPER4YEARS;


	if ((iRem-SECSPERLYEAR)>=0)	// remove years from reminder
	{
		isVisokos=0;
		iRem=iRem-SECSPERLYEAR;

		while ((iRem-SECSPERNYEAR)>=0)
			iRem=iRem-SECSPERNYEAR;
	}

	while (iRem-mon_lengths[isVisokos][iMonth]*SECSPERDAY>=0)
	{
		iRem=iRem-mon_lengths[isVisokos][iMonth]*SECSPERDAY;
		iMonth++;
	}
	
	if (rem)
		*rem=iRem;

	return ++iMonth;	// return order N of month, not an index
}

char getday(time_t tm_t)
{
	char iDay=1;
	time_t rem;
	getmonth(tm_t,&rem);

	while (rem-SECSPERDAY>=0)
	{
		rem=rem-SECSPERDAY;
		iDay++;
	}

	return iDay;
}


void time2tm(time_t tm_t)
{
	time_t rem;

	tm_year=getyear(tm_t);
	tm_mon=getmonth(tm_t,&rem);
	tm_mday=getday(tm_t);
// now determine hour, minutes and sec

	rem=rem-(tm_mday-1)*SECSPERDAY;
	
	tm_hour=0;
	tm_min=0;
	tm_sec=0;

	while (rem-SECSPERHOUR>=0)
	{
		rem=rem-SECSPERHOUR;
		tm_hour++;
	}

	while (rem-SECSPERMIN>=0)
	{
		rem=rem-SECSPERMIN;
		tm_min++;
	}
	
	tm_sec=rem;

}

void tm2time(time_t *tm_t)
{
	int iYear;
	int iCurYear;
	char isVisokos=1;
	char iMonth=0;
	long temp;

	iYear=tm_year;
	iCurYear=iYear;
	
	while(!isvisokos(iYear))	// find previous visokos year
	{
		iYear--;
	}
	
	*tm_t=(iYear-START)/4*SECSPER4YEARS;


	if (iYear<iCurYear)	// add remaining years
	{
		isVisokos=0;

		*tm_t=*tm_t+SECSPERLYEAR;

		while (++iYear<iCurYear)
			*tm_t=*tm_t+SECSPERNYEAR;
	}

	while (iMonth<tm_mon-1)	// add months
	{
		*tm_t=*tm_t+mon_lengths[isVisokos][iMonth]*SECSPERDAY;
		iMonth++;
	}

	temp=(tm_mday-1);
	*tm_t=*tm_t+temp*SECSPERDAY;

	temp=tm_hour;
	*tm_t=*tm_t+temp*SECSPERHOUR;

	temp=tm_min;
	*tm_t=*tm_t+temp*SECSPERMIN;

	*tm_t=*tm_t+tm_sec;
}

